unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ScktComp, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdThreadComponent;

type
  Twebio_ascii_client = class(TForm)
    gb_io: TGroupBox;
    cb_input0: TCheckBox;
    cb_input1: TCheckBox;
    cb_output0: TCheckBox;
    cb_output1: TCheckBox;
    lb_counter0: TLabel;
    lb_counter1: TLabel;
    ed_counter0: TEdit;
    ed_counter1: TEdit;
    bt_counter_read0: TButton;
    bt_counter_read1: TButton;
    bt_counter_clear0: TButton;
    bt_counter_clear1: TButton;
    bt_counter_readall: TButton;
    bt_counter_clearall: TButton;
    lb_counterall: TLabel;
    bt_inputs_read: TButton;
    bt_outputs_read: TButton;
    cb_output_polling: TCheckBox;
    cb_input_polling: TCheckBox;
    cb_counter_polling: TCheckBox;
    Label1: TLabel;
    ed_interval: TEdit;
    gb_connection: TGroupBox;
    Label2: TLabel;
    ed_ip: TEdit;
    ed_port: TEdit;
    bt_connect: TButton;
    bt_disconnect: TButton;
    StatusBar1: TStatusBar;
    timer_polling: TTimer;
    ed_password: TEdit;
    lb_port: TLabel;
    lb_password: TLabel;
    ClientSocket: TIdTCPClient;
    procedure bt_connectClick(Sender: TObject);
    procedure bt_disconnectClick(Sender: TObject);
    procedure cb_outputMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_outputs_readClick(Sender: TObject);
    procedure bt_inputs_readClick(Sender: TObject);
    procedure bt_counter_readClick(Sender: TObject);
    procedure bt_counter_clearClick(Sender: TObject);
    procedure bt_counter_readallClick(Sender: TObject);
    procedure bt_counter_clearallClick(Sender: TObject);
    procedure timer_pollingTimer(Sender: TObject);
    procedure ed_intervalChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ClientSocketConnected(Sender: TObject);
    procedure ClientSocketDisconnected(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    procedure ClientSocketThreadRun(Sender: TIdThreadComponent);
    { Public-Deklarationen }
  end;

var
  webio_ascii_client: Twebio_ascii_client;
  ClientSocketThread : TIdThreadComponent;
  Receivestring : string;

implementation

{$R *.DFM}

procedure Twebio_ascii_client.FormCreate(Sender: TObject);
begin
  ClientSocketThread := TIdThreadComponent.Create();
  ClientSocketThread.onRun := ClientSocketThreadRun;
  StatusBar1.SimpleText := 'No Connection';
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.bt_connectClick(Sender: TObject);
begin
  if ed_ip.Text <> '' then
  begin
    ClientSocket.Host := ed_ip.Text;
    ClientSocket.Port := strtoint(ed_port.Text);
    ClientSocket.Connect;
  end;
end;

procedure Twebio_ascii_client.bt_disconnectClick(Sender: TObject);
begin
  ClientSocket.Disconnect;
end;

procedure Twebio_ascii_client.ClientSocketConnected(Sender: TObject);
begin
  ClientSocketThread.Active := true;
  StatusBar1.SimpleText := 'Connected to ' + ed_ip.Text;
  bt_connect.Enabled := False;
  bt_disconnect.Enabled := True;
  gb_io.Enabled := True;
end;

procedure Twebio_ascii_client.ClientSocketDisconnected(Sender: TObject);
begin
  ClientSocketThread.Active := false;
  ClientSocket.Disconnect;
  StatusBar1.SimpleText := 'No Connection';
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.cb_outputMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if sender = cb_output0 then
    if cb_output0.Checked then
      ClientSocket.IOHandler.
          Write('GET /outputaccess0?PW=' + ed_password.Text + '&State=ON&')
    else
      ClientSocket.IOHandler.
          Write('GET /outputaccess0?PW=' + ed_password.Text + '&State=OFF&')
  else
    if cb_output1.Checked then
      ClientSocket.IOHandler.
          Write('GET /outputaccess1?PW=' + ed_password.Text + '&State=ON&')
    else
      ClientSocket.IOHandler.
          Write('GET /outputaccess1?PW=' + ed_password.Text + '&State=OFF&');
end;

procedure Twebio_ascii_client.bt_outputs_readClick(Sender: TObject);
begin
  ClientSocket.IOHandler.Write('GET /output?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_inputs_readClick(Sender: TObject);
begin
  ClientSocket.IOHandler.Write('GET /input?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counter_readClick(Sender: TObject);
begin
  if sender = bt_counter_read0 then
    ClientSocket.IOHandler.Write('GET /counter0?PW=' + ed_password.Text + '&')
  else
    ClientSocket.IOHandler.Write('GET /counter1?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counter_clearClick(Sender: TObject);
begin
  if sender = bt_counter_clear0 then
    ClientSocket.IOHandler.Write('GET /counterclear0?PW=' + ed_password.Text + '&')
  else
    ClientSocket.IOHandler.Write('GET /counterclear1?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counter_readallClick(Sender: TObject);
begin
  ClientSocket.IOHandler.Write('GET /counter?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_client.bt_counter_clearallClick(Sender: TObject);
begin
  ClientSocket.IOHandler.Write('GET /counterclear?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_client.timer_pollingTimer(Sender: TObject);
begin
  if ClientSocket.Connected and cb_output_polling.Checked then
    ClientSocket.IOHandler.Write('GET /output?PW=' + ed_password.Text + '&');
  if ClientSocket.Connected and cb_input_polling.Checked then
    ClientSocket.IOHandler.Write('GET /input?PW=' + ed_password.Text + '&');
  if ClientSocket.Connected and cb_counter_polling.Checked then
    ClientSocket.IOHandler.Write('GET /counter?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.ed_intervalChange(Sender: TObject);
begin
  timer_polling.Interval := strtoint(ed_interval.Text);
end;

procedure Twebio_ascii_client.ClientSocketThreadRun(Sender: TIdThreadComponent);
var
  Receivechar : string;
  SemiPosition : integer;
  OutputValue : word;
  InputValue : word;
begin
  Receivechar := ClientSocket.IOHandler.ReadString(1);
  if Receivechar[1] <> chr(0) then
    Receivestring := Receivestring + Receivechar
  else
  begin
    if Receivestring[1] = 'o' then
    begin
      OutputValue := StrtoInt('$'+copy(ReceiveString,
       pos(';',ReceiveString)+1,length(ReceiveString)-pos(';',ReceiveString)));
      if OutputValue and 1 = 1 then
        cb_output0.Checked := True
      else
        cb_output0.Checked := False;
      if OutputValue and 2 = 2 then
        cb_output1.Checked := True
      else
        cb_output1.Checked := False;
    end;
    if Receivestring[1] = 'i' then
    begin
      InputValue := StrtoInt('$'+copy(ReceiveString,
         pos(';',ReceiveString)+1,
         length(ReceiveString)-pos(';',ReceiveString)));
      if InputValue and 1 = 1 then
        cb_input0.Checked := True
      else
        cb_input0.Checked := False;
      if InputValue and 2 = 2 then
        cb_input1.Checked := True
      else
        cb_input1.Checked := False;
    end;
    if Receivestring[1] = 'c' then
    begin
      if copy(ReceiveString, 8, 1) = '0' then
        ed_counter0.Text := copy(ReceiveString, 10,length(ReceiveString)-9);
      if copy(ReceiveString, 8, 1) = '1' then
        ed_counter1.Text := copy(ReceiveString, 10,length(ReceiveString)-9);
      if copy(ReceiveString, 8, 1) = ';' then
      begin
        ReceiveString[8] := ' ';
        ed_counter0.Text := copy(ReceiveString, 9, pos(';',ReceiveString)-9);
        ed_counter1.Text := copy(ReceiveString,
          pos(';',ReceiveString)+1,
          length(ReceiveString)-pos(';',ReceiveString));
      end;
    end;
    receivestring := '';
  end;
end;



end.
